// MsgDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "MsgBox.h"
#include "MsgDlg.h"
#include "ViewDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__; 
#endif

/////////////////////////////////////////////////////////////////////////////
// CMsgDlg Dialogfeld

CMsgDlg::CMsgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMsgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMsgDlg)
	m_iSymbol = 0;
	m_iType = 1;
	m_csCaption = _T("");
	m_iDefbutton = 0;
	m_iEqual = 0;
	m_iButtons = 1;
	m_iModal = 0;
	m_iCondition = 0;
	m_csMsg = _T("");
	m_iReturn = -1;
	m_bCaptionVar = TRUE;
	m_bMsgVar = TRUE;
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
}

void CMsgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMsgDlg)
	DDX_Control(pDX, IDC_HAND, m_btnHand);
	DDX_Control(pDX, IDC_QUESTION, m_btnQuestion);
	DDX_Control(pDX, IDC_EXCLAMATION, m_btnExclamation);
	DDX_Control(pDX, IDC_INFORMATION, m_btnInformation);
	DDX_Radio(pDX, IDC_INFORMATION, m_iSymbol);
	DDX_Radio(pDX, IDC_GENERIC, m_iType);
	DDX_Text(pDX, IDC_CAPTION, m_csCaption);
	DDX_Radio(pDX, IDC_DEFBUTTON1, m_iDefbutton);
	DDX_Radio(pDX, IDC_EQUAL, m_iEqual);
	DDX_Radio(pDX, IDC_ABORTRETRYIGNORE, m_iButtons);
	DDX_Radio(pDX, IDC_APPLMODAL, m_iModal);
	DDX_Radio(pDX, IDC_NOCOND, m_iCondition);
	DDX_Text(pDX, IDC_TEXT, m_csMsg);
	DDX_Radio(pDX, IDC_IDOK, m_iReturn);
	DDX_Check(pDX, IDC_CAPTIONVAR, m_bCaptionVar);
	DDX_Check(pDX, IDC_MSGVAR, m_bMsgVar);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMsgDlg, CDialog)
	//{{AFX_MSG_MAP(CMsgDlg)
	ON_BN_CLICKED(IDC_TEST, OnTest)
	ON_BN_CLICKED(IDC_VIEW, OnView)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_KICKIDLE, OnKickIdle)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMsgDlg Nachrichten-Handler
LRESULT CMsgDlg::OnKickIdle (WPARAM wParam, LPARAM lParam)
{
	if(((CButton*)GetDlgItem(IDC_AFX))->GetCheck())
		GetDlgItem(IDC_CAPTION)->EnableWindow(FALSE);
	else
		GetDlgItem(IDC_CAPTION)->EnableWindow(TRUE);

	if(((CButton*)GetDlgItem(IDC_NOCOND))->GetCheck() || ((CButton*)GetDlgItem(IDC_OK))->GetCheck())
	{
		GetDlgItem(IDC_EQUAL)->EnableWindow(FALSE);
		GetDlgItem(IDC_INEQUAL)->EnableWindow(FALSE);

		GetDlgItem(IDC_IDOK)->EnableWindow(FALSE);
		GetDlgItem(IDC_IDCANCEL)->EnableWindow(FALSE);
		GetDlgItem(IDC_IDYES)->EnableWindow(FALSE);
		GetDlgItem(IDC_IDNO)->EnableWindow(FALSE);
		GetDlgItem(IDC_IDABORT)->EnableWindow(FALSE);
		GetDlgItem(IDC_IDIGNORE)->EnableWindow(FALSE);
		GetDlgItem(IDC_IDRETRY)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_EQUAL)->EnableWindow(TRUE);
		GetDlgItem(IDC_INEQUAL)->EnableWindow(TRUE);

		GetDlgItem(IDC_IDOK)->EnableWindow(((CButton*)GetDlgItem(IDC_OK))->GetCheck() ||
										   ((CButton*)GetDlgItem(IDC_OKCANCEL))->GetCheck());
		
		GetDlgItem(IDC_IDCANCEL)->EnableWindow(((CButton*)GetDlgItem(IDC_OKCANCEL))->GetCheck() ||
										   ((CButton*)GetDlgItem(IDC_YESNOCANCEL))->GetCheck() ||
										   ((CButton*)GetDlgItem(IDC_RETRYCANCEL))->GetCheck());

		GetDlgItem(IDC_IDYES)->EnableWindow(((CButton*)GetDlgItem(IDC_YESNO))->GetCheck() ||
										   ((CButton*)GetDlgItem(IDC_YESNOCANCEL))->GetCheck());
		
		GetDlgItem(IDC_IDNO)->EnableWindow(((CButton*)GetDlgItem(IDC_YESNO))->GetCheck() ||
										   ((CButton*)GetDlgItem(IDC_YESNOCANCEL))->GetCheck());

		GetDlgItem(IDC_IDABORT)->EnableWindow(((CButton*)GetDlgItem(IDC_ABORTRETRYIGNORE))->GetCheck());
		
		GetDlgItem(IDC_IDIGNORE)->EnableWindow(((CButton*)GetDlgItem(IDC_ABORTRETRYIGNORE))->GetCheck());

		GetDlgItem(IDC_IDRETRY)->EnableWindow(((CButton*)GetDlgItem(IDC_ABORTRETRYIGNORE))->GetCheck() ||
											  ((CButton*)GetDlgItem(IDC_RETRYCANCEL))->GetCheck());

		BOOL bFound=FALSE;
		for(UINT i=IDC_IDOK; i<=IDC_IDRETRY; i++)
		{
			if(!GetDlgItem(i)->IsWindowEnabled())
				((CButton*)GetDlgItem(i))->SetCheck(0);
			else
			{
				if(((CButton*)GetDlgItem(i))->GetCheck())
					bFound=TRUE;
			}
		}
		if(!bFound)
			ManageReturns();
	}

	return 0;
}


BOOL CMsgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_btnHand.SetIcon(AfxGetApp()->LoadStandardIcon(IDI_HAND));
	m_btnQuestion.SetIcon(AfxGetApp()->LoadStandardIcon(IDI_QUESTION));
	m_btnExclamation.SetIcon(AfxGetApp()->LoadStandardIcon(IDI_EXCLAMATION));
	m_btnInformation.SetIcon(AfxGetApp()->LoadStandardIcon(IDI_ASTERISK));
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}


void CMsgDlg::CreateCode(CString& csResult)
{
	UINT uiStyle=0;
	CString csCode(_T(""));
	CString csStyle(_T(""));
	CString csSpace;

	SetSymbol(uiStyle, csStyle);
	SetButtons(uiStyle, csStyle);
	SetDefButton(uiStyle, csStyle);	
	csStyle.SetAt(0, ' ');

	switch(m_iCondition)
	{
		case bcNo:
			csSpace = _T("           ");
			break;

		case bcIf:
		case bcIfThenElse:
			csSpace = _T("              ");
			csCode += _T("if(");
			break;
	}

	switch(m_iType)
	{
		case btGeneric:
			csCode += _T("::MessageBox(NULL, ");
			break;

		case btCWnd:
			csCode += _T("MessageBox(");
			break;

		case btAfx:
			csCode += _T("AfxMessageBox(");
			break;
	}

	if(m_bMsgVar)
		csCode += _T("_T(\"");

	CString csMsg(m_csMsg);
	csMsg.Replace(_T("\r\n"), _T("\\n"));
	csCode += csMsg;

	if(m_bMsgVar)
		csCode += _T("\")");
	
	csCode += _T(", ");

	if(m_iType != btAfx)
	{
		csCode += _T("\r\n") + csSpace;
		if(m_bCaptionVar)
			csCode += _T("_T(\"");

		csCode += m_csCaption;

		if(m_bCaptionVar)
			csCode += _T("\"),");
	}
	
	csCode += _T("\r\n") + csSpace;
	csCode += csStyle;
	csCode += ')';

	if(m_iCondition)
	{
		int iReturn=0;
		CString csReturn(_T(""));
		SetReturn(iReturn, csReturn);

		csCode += _T("\r\n") + csSpace;
		csCode += csReturn;
		csCode += _T(")\r\n{\r\n}");

		if(m_iCondition == bcIfThenElse)
			csCode += _T("\r\nelse\r\n{\r\n}");
	}
	else
	{
		csCode += ';';
	}

	csResult = csCode;
}

void CMsgDlg::OnTest() 
{
	if(!UpdateData(TRUE))
		return;

	UINT uiStyle=0;
	CString csCode(_T(""));
	SetSymbol(uiStyle, csCode);
	SetButtons(uiStyle, csCode);
	SetDefButton(uiStyle, csCode);	

	switch(m_iType)
	{
		case btGeneric:
			::MessageBox(NULL, m_csMsg, m_csCaption, uiStyle);
			break;

		case btCWnd:
			MessageBox(m_csMsg, m_csCaption, uiStyle);
			break;

		case btAfx:
			AfxMessageBox(m_csMsg, uiStyle);
			break;

		default:
			ASSERT(FALSE);
	}
}

void CMsgDlg::SetSymbol(UINT &uiStyle, CString& csCode)
{
	switch(m_iSymbol)
	{
		case bsInformation:
			uiStyle |= MB_ICONINFORMATION;
			csCode += _T("|MB_ICONINFORMATION");
			break;

		case bsQuestion:
			uiStyle |= MB_ICONQUESTION;
			csCode += _T("|MB_ICONQUESTION");
			break;

		case bsExclamation:
			uiStyle |= MB_ICONEXCLAMATION;
			csCode += _T("|MB_ICONEXCLAMATION");
			break;

		case bsHand:
			uiStyle |= MB_ICONHAND;
			csCode += _T("|MB_ICONHAND");
			break;

		default:
			ASSERT(FALSE);
	}
}

void CMsgDlg::SetButtons(UINT &uiStyle, CString& csCode)
{
	switch(m_iButtons)
	{
		case bbAbortRetryIgnore:
			uiStyle |= MB_ABORTRETRYIGNORE;
			csCode += _T("|MB_ABORTRETRYIGNORE");
			break;

		case bbOk:
			uiStyle |= MB_OK;
			csCode += _T("|MB_OK");
			break;

		case bbOkCancel:
			uiStyle |= MB_OKCANCEL;
			csCode += _T("|MB_OKCANCEL");
			break;

		case bbRetryCancel:
			uiStyle |= MB_RETRYCANCEL;
			csCode += _T("|MB_RETRYCANCEL");
			break;

		case bbYesNo:
			uiStyle |= MB_YESNO;
			csCode += _T("|MB_YESNO");
			break;

		case bbYesNoCancel:
			uiStyle |= MB_YESNOCANCEL;
			csCode += _T("|MB_YESNOCANCEL");
			break;

		default:
			ASSERT(FALSE);
	}
}

void CMsgDlg::SetDefButton(UINT &uiStyle, CString& csCode)
{
	switch(m_iDefbutton)
	{
		case bd1:
			uiStyle |= MB_DEFBUTTON1;
			csCode += _T("|MB_DEFBUTTON1");
			break;

		case bd2:
			uiStyle |= MB_DEFBUTTON2;
			csCode += _T("|MB_DEFBUTTON2");
			break;

		case bd3:
			uiStyle |= MB_DEFBUTTON3;
			csCode += _T("|MB_DEFBUTTON3");
			break;

		default:
			ASSERT(FALSE);
	}
}

void CMsgDlg::ManageReturns()
{
	for(UINT i=IDC_IDOK; i<=IDC_IDRETRY; i++)
	{
		if(GetDlgItem(i)->IsWindowEnabled())
		{
			((CButton*)GetDlgItem(i))->SetCheck(1);
			break;
		}
	}
}

void CMsgDlg::SetReturn(int &iReturn, CString &csReturn)
{
	if(m_iEqual == beEqual)
		csReturn += _T(" == ");
	else
		csReturn += _T(" != ");
	
	switch(m_iReturn)
	{
		case brOk:
			csReturn += _T("IDOK");
			iReturn |= IDOK;
			break;

		case brCancel:
			csReturn += _T("IDCANCEL");
			iReturn |= IDCANCEL;
			break;

		case brYes:
			csReturn += _T("IDYES");
			iReturn |= IDYES;
			break;

		case brNo:
			csReturn += _T("IDNO");
			iReturn |= IDNO;
			break;

		case brAbort:
			csReturn += _T("IDABORT");
			iReturn |= IDABORT;
			break;

		case brIgnore:
			csReturn += _T("IDIGNORE");
			iReturn |= IDIGNORE;
			break;

		case brRetry:
			csReturn += _T("IDRETRY");
			iReturn |= IDRETRY;
			break;

		default:
			ASSERT(FALSE);
	}
}

void CMsgDlg::OnView() 
{
	if(!UpdateData(TRUE))
		return;

	CViewDlg dlg(this);
	CreateCode(dlg.m_csCode);

	dlg.DoModal();
}

void CMsgDlg::OnOK() 
{
	if(!UpdateData(TRUE))
		return;

	CString csCode;
	CreateCode(csCode);

	HGLOBAL hMem = ::GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE, lstrlen((LPCSTR)csCode)+1);
	if(!hMem)
		return;

	lstrcpy((LPSTR)::GlobalLock(hMem), (LPCSTR)csCode);
	::GlobalUnlock(hMem);
   	OpenClipboard();
   	EmptyClipboard();
	SetClipboardData(CF_TEXT, hMem);
   	CloseClipboard();
	
	CDialog::OnOK();
}
